package com.vaadin;

import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import com.liferay.portal.kernel.util.WebKeys;

/**
 * class LiferaySessionServlet: Liferay-specific servlet to accommodate the session extension.
 * 
 * @author dnebinger
 * 
 *         $Id:$
 */
public class LiferaySessionServlet extends HttpServlet {
	private static final long serialVersionUID = -8084050684068845278L;

	/**
	 * @see javax.servlet.http.HttpServlet#service(javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
	 */
	protected void service(final HttpServletRequest request, final HttpServletResponse response) throws ServletException, IOException {
		if (request.getAttribute(WebKeys.EXTEND_SESSION) != null) {
			request.removeAttribute(WebKeys.EXTEND_SESSION);

			final HttpSession session = request.getSession(false);

			if (session != null) {
				session.setAttribute(WebKeys.EXTEND_SESSION, Boolean.TRUE);

				session.removeAttribute(WebKeys.EXTEND_SESSION);
			}

			return;
		}

		super.service(request, response);
	}

}
